int Reverse(int n)
{
int r = 0;
int i;
for (i = 0;i < 8;i++)
	if (n & (1 << i)) r = r | (128 >> i);
return(r);
}

void GenerateRenderingCode(int n)
{
int c[4],i;
char *Register[] = { "XXXX","A","C","D" };
printf("; ");
for (i = 0;i < 4;i++)
	{
	c[i] = (n & 8) ? 1 : 0;
	if (n & 128) c[i] = c[i]+2;
	n = (n << 1);
	printf("%d:%d ",i,c[i]);
	}
printf("\n");
if (c[0] == c[1] && c[1] == c[2] && c[2] == c[3])
	{
	if (c[0] != 0) printf("    mov [ebp],e%sx\n",Register[c[0]]);
	printf("    ret\n");
	return;
	}
i = 0;
while (i < 3)
	{
	if (c[i] == c[i+1])
		{
		if (c[i] != 0)
			printf("    mov [ebp+%d],%sX\n",i,Register[c[i]]);
		i = i+2;
		}
	else
		{
		if (c[i] != 0)
			printf("    mov [ebp+%d],%sL\n",i,Register[c[i]]);
		i = i+1;
		}
	}
if (i == 3 && c[i] != 0)
		printf("    mov [ebp+%d],%sL\n",i,Register[c[i]]);
printf("    ret\n");
}

void main()
{
int i;
for (i = 0;i < 256;i++)
	{
	printf("Render%03d:\n",i);
	GenerateRenderingCode(i);
	}
printf("RenderVector:\n");
for (i = 0;i < 256;i++)
	printf("    dd Render%03d\n",i);
printf("ReversePixel:\n");
for (i = 0;i < 256;i++)
	printf("    db %d\n",Reverse(i));
}